﻿/*
	rcxmerge
	Copyright (C) 2010-2011 Jonathan Zarate
	http://www.polarcloud.com/

	---

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

var rcxMerge = {
	go: function() {

		const nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes['@mozilla.org/filepicker;1'].createInstance(nsIFilePicker);

		var d = this.pickDB();
		if (d) {
			fp.init(window, 'Import which file?', nsIFilePicker.modeOpen);
			fp.appendFilters(nsIFilePicker.filterAll);
			var r = fp.show();
			if (r == nsIFilePicker.returnOK) {
				this.append(d[0], d[1], fp.file.path);
			}
		}
	},
	
	pickDB: function() {
		var n = 0;
		if (typeof(rcxDicList) != 'undefined') {
			for (var id in rcxDicList) {
				var d = rcxDicList[id];
				if (!d.isKanji) {
					++n;
					if (confirm('Merge entries into the dictionary [' + d.name + ']?')) return [id, d.name];
				}
			}
		}
		if (n == 0) alert('No existing dictionary files found');
		return null;

/*		
		var pb = Components.classes['@mozilla.org/preferences-service;1']
				.getService(Components.interfaces.nsIPrefService)
				.getBranch('rikaichan.');
		var s = pb.getCharPref('dpriority').split('|');
		var n = 0;
		for (var i = 0; i < s.length; ++i) {
			if (s[i].match(/(.+?)#(.+)/)) {
				++n;
				var id = RegExp.$1;
				var name = RegExp.$2;
				if ((!id.match(/\@local/)) && (confirm('Append to ' + name + '?')))
					return [id, name];
			}
		}
		if (n == 0) alert('No existing dictionary files found');
		return null;
*/
	},
	
	// katakana -> hiragana conversion tables
	ch:[0x3092,0x3041,0x3043,0x3045,0x3047,0x3049,0x3083,0x3085,0x3087,0x3063,0x30FC,0x3042,0x3044,0x3046,
		0x3048,0x304A,0x304B,0x304D,0x304F,0x3051,0x3053,0x3055,0x3057,0x3059,0x305B,0x305D,0x305F,0x3061,
		0x3064,0x3066,0x3068,0x306A,0x306B,0x306C,0x306D,0x306E,0x306F,0x3072,0x3075,0x3078,0x307B,0x307E,
		0x307F,0x3080,0x3081,0x3082,0x3084,0x3086,0x3088,0x3089,0x308A,0x308B,0x308C,0x308D,0x308F,0x3093],
	cv:[0x30F4,0xFF74,0xFF75,0x304C,0x304E,0x3050,0x3052,0x3054,0x3056,0x3058,0x305A,0x305C,0x305E,0x3060,
		0x3062,0x3065,0x3067,0x3069,0xFF85,0xFF86,0xFF87,0xFF88,0xFF89,0x3070,0x3073,0x3076,0x3079,0x307C],
	cs:[0x3071,0x3074,0x3077,0x307A,0x307D],

	toHiragana: function(word) {
		var p = 0;
		var r = '';
		for (var i = 0; i < word.length; ++i) {
			var u = word.charCodeAt(i);
			var v = u;

			if (u <= 0x3000) break;

			// full-width katakana to hiragana
			if ((u >= 0x30A1) && (u <= 0x30F3)) {
				u -= 0x60;
			}
			// half-width katakana to hiragana
			else if ((u >= 0xFF66) && (u <= 0xFF9D)) {
				u = this.ch[u - 0xFF66];
			}
			// voiced (used in half-width katakana) to hiragana
			else if (u == 0xFF9E) {
				if ((p >= 0xFF73) && (p <= 0xFF8E)) {
					r = r.substr(0, r.length - 1);
					u = this.cv[p - 0xFF73];
				}
			}
			// semi-voiced (used in half-width katakana) to hiragana
			else if (u == 0xFF9F) {
				if ((p >= 0xFF8A) && (p <= 0xFF8E)) {
					r = r.substr(0, r.length - 1);
					u = this.cs[p - 0xFF8A];
				}
			}
			// ignore J~
			else if (u == 0xFF5E) {
				p = 0;
				continue;
			}

			r += String.fromCharCode(u);
			p = v;
		}
		return r;
	},
	
	append: function(dbId, dbName, fname) {
		var buffer = null;
		var encodings = ['UTF-8', 'EUC-JP', 'SHIFT-JIS'];
		for (var i = 0; i < encodings.length; ++i) {
			buffer = this.readArray(fname, encodings[i]);
			if (buffer.length >= 1) {
				if (confirm('Using encoding ' + encodings[i] + '. Example (2 lines):\n\n' +
					buffer[1] + '\n' + buffer[2] + '\n\nIs the text readable (no garbage characters)?')) {
					break;
				}
			}
			buffer = null;
		}
		
		if (!buffer) {
			alert('Unknown encoding');
			return;
		}
		
		var dic = RcxMergeDb(dbId + '|dict.sqlite');
		try {
			dic.open();
			dic.beginTransaction();

			if (confirm('Erase ALL existing entries in [' + dbName + ']?')) {
				try {
					dic.exec('DELETE FROM dict');
				}
				catch (ex) {
					alert('Exception: ' + ex);
				}
			}

			if (confirm('This may take a few minutes to complete... Ready?')) {
			
				try {
					dic.exec('CREATE UNIQUE INDEX IF NOT EXISTS unique_temp ON dict (kanji,kana)');
				}
				catch (ex) {
//					alert('Exception: ' + ex);
				}

				var count = 0;
				for (var i = 0; i < buffer.length; ++i) {
					var entry = buffer[i];

					var j = entry.indexOf('/');
					if (j < 0) continue;

					var s = entry.substring(0, j - 1);
					var kanji, kana;
					if (s.match(/^\s*(.+?)\s*\[\s*(.+?)\s*\]/)) {
						kanji = this.toHiragana(RegExp.$1);
						kana = this.toHiragana(RegExp.$2);
					}
					else {
						kanji = null;
						kana = this.toHiragana(s);
					}

					// handle duplicate kanji+kana pair somehow - delete them.
					if (kanji == null) dic.exec('DELETE FROM dict WHERE kanji IS NULL AND kana=?1', kana);
						else dic.exec('DELETE FROM dict WHERE kanji=?1 AND kana=?2', kanji, kana);

					dic.exec('REPLACE INTO dict (kanji,kana,entry) VALUES (?1,?2,?3)', kanji, kana, entry);
					++count;
				}

				dic.commitTransaction();
				try {
					dic.exec('DROP INDEX unique_temp');
				}
				catch (ex) { }

				try {
					dic.exec('VACUUM');
				}
				catch (ex) { }

				alert('Done! ' + count + ' entries were written.');
			}
			else {
				dic.rollbackTransaction();
				alert('Aborted');
			}
		}
		catch (ex) {
			alert('Exception: ' + ex);
		}
		if (dic) {
			dic.close();
			dic = null;
		}
	},
	
	read: function(fname, cp) {
		var f = Components.classes['@mozilla.org/file/local;1']
			.createInstance(Components.interfaces.nsILocalFile);
		f.initWithPath(fname);
			
		var fis = Components.classes['@mozilla.org/network/file-input-stream;1']
				.createInstance(Components.interfaces.nsIFileInputStream);
		fis.init(f, -1, -1, 0);
				
		var is = Components.classes['@mozilla.org/intl/converter-input-stream;1']
                   .createInstance(Components.interfaces.nsIConverterInputStream);
		is.init(fis, cp, 4 * 1024 * 1024,
			Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);

		var buffer = '';
		var s = {};
		while (is.readString(-1, s) > 0) {
			buffer += s.value;
		}
		is.close();
		
		return buffer;
	},

	readArray: function(name, cp) {
		var a = this.read(name, cp).split('\n');
		while ((a.length > 0) && (a[a.length - 1].length == 0)) a.pop();
		return a;
	}	
};


function RcxMergeDb(name)
{
	this.open = function() {
		var f;

		if (name.match(/(.+)\|(.+)/)) {
			let id = RegExp.$1;
			let nm = RegExp.$2;
			try {
				f = Components.classes['@mozilla.org/extensions/manager;1']
					.getService(Components.interfaces.nsIExtensionManager)
					.getInstallLocation(id).getItemFile(id, nm);
			}
			catch (ex) {
				if ((rcxData.dicPath) && (rcxData.dicPath[id])) {
					f = Components.classes['@mozilla.org/file/local;1']
						.createInstance(Components.interfaces.nsILocalFile);
					f.initWithPath(rcxData.dicPath[id]);
					f.append(nm);
				}

				if (!f) throw 'Could not find or open ' + id + '/' + nm;
			}
		}
		else {
			f = Components.classes['@mozilla.org/file/local;1']
				.createInstance(Components.interfaces.nsILocalFile);
			f.initWithPath(name);
		}

//		alert('Path: ' + f.path);

		// The files may get installed as read-only, breaking
		// index creation. Try changing the file permission.
		if (!f.isWritable()) f.permissions |= 0600;

		this.db = Components.classes['@mozilla.org/storage/service;1']
			.getService(Components.interfaces.mozIStorageService)
			.openDatabase(f);
	};

	this.close = function() {
		if (this.db) {
			try {
				this.db.close();
			}
			catch (ex) {
			}
			this.db = null;
		}
	};

	this.exec = function(stm) {
		var rows = [];
		if (!this.db) this.open();
		var st = this.db.createStatement(stm);
		for (var i = arguments.length - 1; i > 0; --i) {
			if (arguments[i] != null) st.bindUTF8StringParameter(i - 1, arguments[i]);
		}
		while (st.executeStep()) {
			var r = [];
			for (var i = st.columnCount - 1; i >= 0; --i) {
				r[st.getColumnName(i)] = st.getUTF8String(i);
			}
			rows.push(r);
		}
		return rows;
	};
	
	this.indexExists = function(index) {
		if (!this.db) this.open();
		return this.db.indexExists(index);
	};

	this.beginTransaction = function() {
		if (!this.db) this.open();
		this.db.beginTransaction();
	};

	this.commitTransaction = function() {
		this.db.commitTransaction();
	};

	this.rollbackTransaction = function() {
		this.db.rollbackTransaction();
	};

	return this;
}
